{-

Links-Rekursion

-------------------------------------------------------

Vortrag: Monadische Parser
Syntax-Analyse mit Haskell
(Funktionale Programmierung WS 08/09)

Mathias Mierswa (winf2920) und Thomas Stuht (inf6937)

8. Januar 2009

-}

module LeftRec where

import ParseFct

data Expr = Con Int | Bin Op Expr Expr deriving Show
data Op = Plus | Minus deriving Show

expr :: Parser Expr
expr = exOr term factor

term = do {t <- expr; op <- addop; u <- factor; return (Bin op t u)}

addop = exOr (do {symbol "+"; return Plus})
             (do {symbol "-"; return Minus})
             
factor = exOr (token const') (do {symbol "("; e <- expr; symbol ")"; return e})

{- const aus module Prelude-}
const' = do {n <- integer; return (Con n)}


{- Verbesserung -}
expr' :: Parser Expr
expr' = do {t <- factor; rest t}
rest t = exOr (do {op <- addop; u <- factor; rest (Bin op t u)}) (return t)


pWrong = parse expr "42"
pRight = parse expr' "42"
